Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -2941,38 +2914,37 @@
 
     IF (cvflag_prec_eject) THEN
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       IF (adiab_ascent_mass_flux_depends_on_ejectliq) THEN
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!!! Warning : this option leads to water conservation violation
-!!!           Expert only
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          IF ( i > 1) THEN
-            DO il = 1, ncum
-              IF (i<=inb(il) .AND. lwork(il)) THEN
-                wdtrainA(il,i) = ma(il, i+1)*(qta(il, i-1)-qta(il,i))/(1. - qta(il, i-1))    !   Pa   jygprl
-                wdtrain(il) = wdtrain(il) + grav*wdtrainA(il,i)
-              END IF
-            END DO
-          ENDIF  ! ( i > 1)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        !!! Warning : this option leads to water conservation violation
+        !!!           Expert only
+        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        IF (i > 1) THEN
+          DO il = 1, ncum
+            IF (i<=inb(il) .AND. lwork(il)) THEN
+              wdtrainA(il, i) = ma(il, i + 1) * (qta(il, i - 1) - qta(il, i)) / (1. - qta(il, i - 1))    !   Pa   jygprl
+              wdtrain(il) = wdtrain(il) + grav * wdtrainA(il, i)
+            END IF
+          END DO
+        ENDIF  ! ( i > 1)
+        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       ELSE ! (adiab_ascent_mass_flux_depends_on_ejectliq)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          IF ( i > 1) THEN
-            DO il = 1, ncum
-              IF (i<=inb(il) .AND. lwork(il)) THEN
-                wdtrainA(il,i) = ma(il, i+1)*(qta(il, i-1)-qta(il,i))                        !   Pa   jygprl
-                wdtrain(il) = wdtrain(il) + grav*wdtrainA(il,i)
-              END IF
-            END DO
-          ENDIF  ! ( i > 1)
+        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        IF (i > 1) THEN
+          DO il = 1, ncum
+            IF (i<=inb(il) .AND. lwork(il)) THEN
+              wdtrainA(il, i) = ma(il, i + 1) * (qta(il, i - 1) - qta(il, i))                        !   Pa   jygprl
+              wdtrain(il) = wdtrain(il) + grav * wdtrainA(il, i)
+            END IF
+          END DO
+        ENDIF  ! ( i > 1)
 
       ENDIF ! (adiab_ascent_mass_flux_depends_on_ejectliq) ELSE
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     ENDIF  ! (cvflag_prec_eject)
 
 
-! ***    find rain water and evaporation using provisional   ***
-! ***              estimates of rp(i)and rp(i-1)             ***
-
+    ! ***    find rain water and evaporation using provisional   ***
+    ! ***              estimates of rp(i)and rp(i-1)             ***
 
     IF (cvflag_ice) THEN                                                                                !!jygprl
@@ -2980,6 +2952,6 @@
         DO il = 1, ncum                                                                                   !!jygprl
           IF (i<=inb(il) .AND. lwork(il)) THEN                                                            !!jygprl
-            frac(il, i) = (frac_a(il,i)*wdtrainA(il,i)+frac_s(il,i)*(wdtrainS(il,i)+wdtrainM(il,i))) / &  !!jygprl
-                          max(wdtrainA(il,i)+wdtrainS(il,i)+wdtrainM(il,i),smallestreal)                  !!jygprl
+            frac(il, i) = (frac_a(il, i) * wdtrainA(il, i) + frac_s(il, i) * (wdtrainS(il, i) + wdtrainM(il, i))) / &  !!jygprl
+                    max(wdtrainA(il, i) + wdtrainS(il, i) + wdtrainM(il, i), smallestreal)                  !!jygprl
             fraci(il, i) = frac(il, i)                                                                    !!jygprl
           END IF                                                                                          !!jygprl
@@ -2988,18 +2960,18 @@
         DO il = 1, ncum                                                                                   !!jygprl
           IF (i<=inb(il) .AND. lwork(il)) THEN                                                            !!jygprl
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             IF (keepbug_ice_frac) THEN
               frac(il, i) = frac_s(il, i)
-!       Ice fraction computed again here as a function of the temperature seen by unsaturated downdraughts
-!       (i.e. the cold pool temperature) for compatibility with earlier versions.
-              fraci(il, i) = 1. - (t(il,i)-243.15)/(263.15-243.15)
-              fraci(il, i) = min(max(fraci(il,i),0.0), 1.0)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+              !       Ice fraction computed again here as a function of the temperature seen by unsaturated downdraughts
+              !       (i.e. the cold pool temperature) for compatibility with earlier versions.
+              fraci(il, i) = 1. - (t(il, i) - 243.15) / (263.15 - 243.15)
+              fraci(il, i) = min(max(fraci(il, i), 0.0), 1.0)
+              !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             ELSE  ! (keepbug_ice_frac)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+              !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
               frac(il, i) = frac_s(il, i)
               fraci(il, i) = frac(il, i)                                                                    !!jygprl
             ENDIF  ! (keepbug_ice_frac)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
           END IF                                                                                          !!jygprl
         END DO                                                                                            !!jygprl
@@ -3007,5 +2979,4 @@
     END IF                                                                                              !!jygprl
 
-
     DO il = 1, ncum
       IF (i<=inb(il) .AND. lwork(il)) THEN
@@ -3014,212 +2985,212 @@
 
         IF (i<inb(il)) THEN
-          rp(il, i) = rp(il, i+1) + &
-                      (cpd*(t(il,i+1)-t(il,i))+gz(il,i+1)-gz(il,i))/lv(il, i)
-          rp(il, i) = 0.5*(rp(il,i)+rr(il,i))
+          rp(il, i) = rp(il, i + 1) + &
+                  (cpd * (t(il, i + 1) - t(il, i)) + gz(il, i + 1) - gz(il, i)) / lv(il, i)
+          rp(il, i) = 0.5 * (rp(il, i) + rr(il, i))
         END IF
-        rp(il, i) = max(rp(il,i), 0.0)
-        rp(il, i) = amin1(rp(il,i), rs(il,i))
+        rp(il, i) = max(rp(il, i), 0.0)
+        rp(il, i) = amin1(rp(il, i), rs(il, i))
         rp(il, inb(il)) = rr(il, inb(il))
 
         IF (i==1) THEN
-          afac = p(il, 1)*(rs(il,1)-rp(il,1))/(1.0E4+2000.0*p(il,1)*rs(il,1))
+          afac = p(il, 1) * (rs(il, 1) - rp(il, 1)) / (1.0E4 + 2000.0 * p(il, 1) * rs(il, 1))
           IF (cvflag_ice) THEN
-            afac1 = p(il, i)*(rs(il,1)-rp(il,1))/(1.0E4+2000.0*p(il,1)*rs(il,1))
+            afac1 = p(il, i) * (rs(il, 1) - rp(il, 1)) / (1.0E4 + 2000.0 * p(il, 1) * rs(il, 1))
           END IF
         ELSE
-          rp(il, i-1) = rp(il, i) + (cpd*(t(il,i)-t(il,i-1))+gz(il,i)-gz(il,i-1))/lv(il, i)
-          rp(il, i-1) = 0.5*(rp(il,i-1)+rr(il,i-1))
-          rp(il, i-1) = amin1(rp(il,i-1), rs(il,i-1))
-          rp(il, i-1) = max(rp(il,i-1), 0.0)
-          afac1 = p(il, i)*(rs(il,i)-rp(il,i))/(1.0E4+2000.0*p(il,i)*rs(il,i))
-          afac2 = p(il, i-1)*(rs(il,i-1)-rp(il,i-1))/(1.0E4+2000.0*p(il,i-1)*rs(il,i-1))
-          afac = 0.5*(afac1+afac2)
+          rp(il, i - 1) = rp(il, i) + (cpd * (t(il, i) - t(il, i - 1)) + gz(il, i) - gz(il, i - 1)) / lv(il, i)
+          rp(il, i - 1) = 0.5 * (rp(il, i - 1) + rr(il, i - 1))
+          rp(il, i - 1) = amin1(rp(il, i - 1), rs(il, i - 1))
+          rp(il, i - 1) = max(rp(il, i - 1), 0.0)
+          afac1 = p(il, i) * (rs(il, i) - rp(il, i)) / (1.0E4 + 2000.0 * p(il, i) * rs(il, i))
+          afac2 = p(il, i - 1) * (rs(il, i - 1) - rp(il, i - 1)) / (1.0E4 + 2000.0 * p(il, i - 1) * rs(il, i - 1))
+          afac = 0.5 * (afac1 + afac2)
         END IF
         IF (i==inb(il)) afac = 0.0
         afac = max(afac, 0.0)
-        bfac = 1./(sigd(il)*wt(il,i))
-
-    IF (prt_level >= 20) THEN
-      Print*, 'cv3_unsat after provisional rp estimate: rp, afac, bfac ', &
-          i, rp(1, i), afac,bfac
-    ENDIF
-
-!JYG1
-! cc        sigt=1.0
-! cc        IF(i.ge.icb)sigt=sigp(i)
-! prise en compte de la variation progressive de sigt dans
-! les couches icb et icb-1:
-! pour plcl<ph(i+1), pr1=0 & pr2=1
-! pour plcl>ph(i),   pr1=1 & pr2=0
-! pour ph(i+1)<plcl<ph(i), pr1 est la proportion a cheval
-! sur le nuage, et pr2 est la proportion sous la base du
-! nuage.
-        pr1 = (plcl(il)-ph(il,i+1))/(ph(il,i)-ph(il,i+1))
-        pr1 = max(0., min(1.,pr1))
-        pr2 = (ph(il,i)-plcl(il))/(ph(il,i)-ph(il,i+1))
-        pr2 = max(0., min(1.,pr2))
-        sigt = sigp(il, i)*pr1 + pr2
-!JYG2
-
-!JYG----
-!    b6 = bfac*100.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac
-!    c6 = water(il,i+1) + wdtrain(il)*bfac
-!    c6 = prec(il,i+1) + wdtrain(il)*bfac
-!    revap=0.5*(-b6+sqrt(b6*b6+4.*c6))
-!    evap(il,i)=sigt*afac*revap
-!    water(il,i)=revap*revap
-!    prec(il,i)=revap*revap
-!!        print *,' i,b6,c6,revap,evap(il,i),water(il,i),wdtrain(il) ', &
-!!                 i,b6,c6,revap,evap(il,i),water(il,i),wdtrain(il)
-!!---end jyg---
-
-! --------retour à la formulation originale d'Emanuel.
+        bfac = 1. / (sigd(il) * wt(il, i))
+
+        IF (prt_level >= 20) THEN
+          Print*, 'cv3_unsat after provisional rp estimate: rp, afac, bfac ', &
+                  i, rp(1, i), afac, bfac
+        ENDIF
+
+        !JYG1
+        ! cc        sigt=1.0
+        ! cc        IF(i.ge.icb)sigt=sigp(i)
+        ! prise en compte de la variation progressive de sigt dans
+        ! les couches icb et icb-1:
+        ! pour plcl<ph(i+1), pr1=0 & pr2=1
+        ! pour plcl>ph(i),   pr1=1 & pr2=0
+        ! pour ph(i+1)<plcl<ph(i), pr1 est la proportion a cheval
+        ! sur le nuage, et pr2 est la proportion sous la base du
+        ! nuage.
+        pr1 = (plcl(il) - ph(il, i + 1)) / (ph(il, i) - ph(il, i + 1))
+        pr1 = max(0., min(1., pr1))
+        pr2 = (ph(il, i) - plcl(il)) / (ph(il, i) - ph(il, i + 1))
+        pr2 = max(0., min(1., pr2))
+        sigt = sigp(il, i) * pr1 + pr2
+        !JYG2
+
+        !JYG----
+        !    b6 = bfac*100.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac
+        !    c6 = water(il,i+1) + wdtrain(il)*bfac
+        !    c6 = prec(il,i+1) + wdtrain(il)*bfac
+        !    revap=0.5*(-b6+sqrt(b6*b6+4.*c6))
+        !    evap(il,i)=sigt*afac*revap
+        !    water(il,i)=revap*revap
+        !    prec(il,i)=revap*revap
+        !!        print *,' i,b6,c6,revap,evap(il,i),water(il,i),wdtrain(il) ', &
+        !!                 i,b6,c6,revap,evap(il,i),water(il,i),wdtrain(il)
+        !!---end jyg---
+
+        ! --------retour à la formulation originale d'Emanuel.
         IF (cvflag_ice) THEN
 
-!   b6=bfac*50.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac
-!   c6=prec(il,i+1)+bfac*wdtrain(il) &
-!       -50.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il,i+1)
-!   IF(c6.gt.0.0)THEN
-!   revap=0.5*(-b6+sqrt(b6*b6+4.*c6))
-
-!JAM  Attention: evap=sigt*E
-!    Modification: evap devient l'évaporation en milieu de couche
-!    car nécessaire dans cv3_yield
-!    Du coup, il faut modifier pas mal d'équations...
-!    et l'expression de afac qui devient afac1
-!    revap=sqrt((prec(i+1)+prec(i))/2)
-
-          b6 = bfac*50.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac1
-          c6 = prec(il, i+1) + 0.5*bfac*wdtrain(il)
-! print *,'bfac,sigd(il),sigt,afac1 ',bfac,sigd(il),sigt,afac1
-! print *,'prec(il,i+1),wdtrain(il) ',prec(il,i+1),wdtrain(il)
-! print *,'b6,c6,b6*b6+4.*c6 ',b6,c6,b6*b6+4.*c6
-          IF (c6>b6*b6+1.E-20) THEN
-            revap = 2.*c6/(b6+sqrt(b6*b6+4.*c6))
+          !   b6=bfac*50.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac
+          !   c6=prec(il,i+1)+bfac*wdtrain(il) &
+          !       -50.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il,i+1)
+          !   IF(c6.gt.0.0)THEN
+          !   revap=0.5*(-b6+sqrt(b6*b6+4.*c6))
+
+          !JAM  Attention: evap=sigt*E
+          !    Modification: evap devient l'évaporation en milieu de couche
+          !    car nécessaire dans cv3_yield
+          !    Du coup, il faut modifier pas mal d'équations...
+          !    et l'expression de afac qui devient afac1
+          !    revap=sqrt((prec(i+1)+prec(i))/2)
+
+          b6 = bfac * 50. * sigd(il) * (ph(il, i) - ph(il, i + 1)) * sigt * afac1
+          c6 = prec(il, i + 1) + 0.5 * bfac * wdtrain(il)
+          ! print *,'bfac,sigd(il),sigt,afac1 ',bfac,sigd(il),sigt,afac1
+          ! print *,'prec(il,i+1),wdtrain(il) ',prec(il,i+1),wdtrain(il)
+          ! print *,'b6,c6,b6*b6+4.*c6 ',b6,c6,b6*b6+4.*c6
+          IF (c6>b6 * b6 + 1.E-20) THEN
+            revap = 2. * c6 / (b6 + sqrt(b6 * b6 + 4. * c6))
           ELSE
-            revap = (-b6+sqrt(b6*b6+4.*c6))/2.
+            revap = (-b6 + sqrt(b6 * b6 + 4. * c6)) / 2.
           END IF
-          prec(il, i) = max(0., 2.*revap*revap-prec(il,i+1))
-! PRINT*,prec(il,i),'neige'
-
-!JYG    Dans sa formulation originale, Emanuel calcule l'evaporation par:
-! c             evap(il,i)=sigt*afac*revap
-! ce qui n'est pas correct. Dans cv_routines, la formulation a été modifiee.
-! Ici,l'evaporation evap est simplement calculee par l'equation de
-! conservation.
-! prec(il,i)=revap*revap
-! else
-!JYG----   Correction : si c6 <= 0, water(il,i)=0.
-! prec(il,i)=0.
-! END IF
-
-!JYG---   Dans tous les cas, evaporation = [tt ce qui entre dans la couche i]
-! moins [tt ce qui sort de la couche i]
-! print *, 'evap avec ice'
-          evap(il, i) = (wdtrain(il)+sigd(il)*wt(il,i)*(prec(il,i+1)-prec(il,i))) / &
-                        (sigd(il)*(ph(il,i)-ph(il,i+1))*100.)
-
-    IF (prt_level >= 20) THEN
-      Print*, 'cv3_unsat after evap computation: wdtrain, sigd, wt, prec(i+1),prec(i) ', &
-          i, wdtrain(1), sigd(1), wt(1,i), prec(1,i+1),prec(1,i)
-    ENDIF
-
-!jyg<
-          d6 = prec(il,i)-prec(il,i+1)
-
-!!          d6 = bfac*wdtrain(il) - 100.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i)
-!!          e6 = bfac*wdtrain(il)
-!!          f6 = -100.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i)
-!>jyg
-!CR:tmax_fonte_cv: T for which ice is totally melted (used to be 275.15)
-          thaw = (t(il,i)-273.15)/(tmax_fonte_cv-273.15)
-          thaw = min(max(thaw,0.0), 1.0)
-!jyg<
-          water(il, i) = water(il, i+1) + (1-fraci(il,i))*d6
-          ice(il, i)   = ice(il, i+1)   + fraci(il, i)*d6
-          water(il, i) = min(prec(il,i), max(water(il,i), 0.))
-          ice(il, i)   = min(prec(il,i), max(ice(il,i),   0.))
-
-!!          water(il, i) = water(il, i+1) + (1-fraci(il,i))*d6
-!!          water(il, i) = max(water(il,i), 0.)
-!!          ice(il, i) = ice(il, i+1) + fraci(il, i)*d6
-!!          ice(il, i) = max(ice(il,i), 0.)
-!>jyg
-          fondue(il, i) = ice(il, i)*thaw
+          prec(il, i) = max(0., 2. * revap * revap - prec(il, i + 1))
+          ! PRINT*,prec(il,i),'neige'
+
+          !JYG    Dans sa formulation originale, Emanuel calcule l'evaporation par:
+          ! c             evap(il,i)=sigt*afac*revap
+          ! ce qui n'est pas correct. Dans cv_routines, la formulation a été modifiee.
+          ! Ici,l'evaporation evap est simplement calculee par l'equation de
+          ! conservation.
+          ! prec(il,i)=revap*revap
+          ! else
+          !JYG----   Correction : si c6 <= 0, water(il,i)=0.
+          ! prec(il,i)=0.
+          ! END IF
+
+          !JYG---   Dans tous les cas, evaporation = [tt ce qui entre dans la couche i]
+          ! moins [tt ce qui sort de la couche i]
+          ! print *, 'evap avec ice'
+          evap(il, i) = (wdtrain(il) + sigd(il) * wt(il, i) * (prec(il, i + 1) - prec(il, i))) / &
+                  (sigd(il) * (ph(il, i) - ph(il, i + 1)) * 100.)
+
+          IF (prt_level >= 20) THEN
+            Print*, 'cv3_unsat after evap computation: wdtrain, sigd, wt, prec(i+1),prec(i) ', &
+                    i, wdtrain(1), sigd(1), wt(1, i), prec(1, i + 1), prec(1, i)
+          ENDIF
+
+          !jyg<
+          d6 = prec(il, i) - prec(il, i + 1)
+
+          !!          d6 = bfac*wdtrain(il) - 100.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i)
+          !!          e6 = bfac*wdtrain(il)
+          !!          f6 = -100.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i)
+          !>jyg
+          !CR:tmax_fonte_cv: T for which ice is totally melted (used to be 275.15)
+          thaw = (t(il, i) - 273.15) / (tmax_fonte_cv - 273.15)
+          thaw = min(max(thaw, 0.0), 1.0)
+          !jyg<
+          water(il, i) = water(il, i + 1) + (1 - fraci(il, i)) * d6
+          ice(il, i) = ice(il, i + 1) + fraci(il, i) * d6
+          water(il, i) = min(prec(il, i), max(water(il, i), 0.))
+          ice(il, i) = min(prec(il, i), max(ice(il, i), 0.))
+
+          !!          water(il, i) = water(il, i+1) + (1-fraci(il,i))*d6
+          !!          water(il, i) = max(water(il,i), 0.)
+          !!          ice(il, i) = ice(il, i+1) + fraci(il, i)*d6
+          !!          ice(il, i) = max(ice(il,i), 0.)
+          !>jyg
+          fondue(il, i) = ice(il, i) * thaw
           water(il, i) = water(il, i) + fondue(il, i)
           ice(il, i) = ice(il, i) - fondue(il, i)
 
-          IF (water(il,i)+ice(il,i)<1.E-30) THEN
+          IF (water(il, i) + ice(il, i)<1.E-30) THEN
             faci(il, i) = 0.
           ELSE
-            faci(il, i) = ice(il, i)/(water(il,i)+ice(il,i))
+            faci(il, i) = ice(il, i) / (water(il, i) + ice(il, i))
           END IF
 
-!           water(il,i)=water(il,i+1)+(1.-fraci(il,i))*e6+(1.-faci(il,i))*f6
-!           water(il,i)=max(water(il,i),0.)
-!           ice(il,i)=ice(il,i+1)+fraci(il,i)*e6+faci(il,i)*f6
-!           ice(il,i)=max(ice(il,i),0.)
-!           fondue(il,i)=ice(il,i)*thaw
-!           water(il,i)=water(il,i)+fondue(il,i)
-!           ice(il,i)=ice(il,i)-fondue(il,i)
-            
-!           if((water(il,i)+ice(il,i)).lt.1.e-30)THEN
-!             faci(il,i)=0.
-!           else
-!             faci(il,i)=ice(il,i)/(water(il,i)+ice(il,i))
-!           endif
+          !           water(il,i)=water(il,i+1)+(1.-fraci(il,i))*e6+(1.-faci(il,i))*f6
+          !           water(il,i)=max(water(il,i),0.)
+          !           ice(il,i)=ice(il,i+1)+fraci(il,i)*e6+faci(il,i)*f6
+          !           ice(il,i)=max(ice(il,i),0.)
+          !           fondue(il,i)=ice(il,i)*thaw
+          !           water(il,i)=water(il,i)+fondue(il,i)
+          !           ice(il,i)=ice(il,i)-fondue(il,i)
+
+          !           if((water(il,i)+ice(il,i)).lt.1.e-30)THEN
+          !             faci(il,i)=0.
+          !           else
+          !             faci(il,i)=ice(il,i)/(water(il,i)+ice(il,i))
+          !           endif
 
         ELSE
-          b6 = bfac*50.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac
-          c6 = water(il, i+1) + bfac*wdtrain(il) - &
-               50.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i+1)
+          b6 = bfac * 50. * sigd(il) * (ph(il, i) - ph(il, i + 1)) * sigt * afac
+          c6 = water(il, i + 1) + bfac * wdtrain(il) - &
+                  50. * sigd(il) * bfac * (ph(il, i) - ph(il, i + 1)) * evap(il, i + 1)
           IF (c6>0.0) THEN
-            revap = 0.5*(-b6+sqrt(b6*b6+4.*c6))
-            water(il, i) = revap*revap
+            revap = 0.5 * (-b6 + sqrt(b6 * b6 + 4. * c6))
+            water(il, i) = revap * revap
           ELSE
             water(il, i) = 0.
           END IF
-! print *, 'evap sans ice'
-          evap(il, i) = (wdtrain(il)+sigd(il)*wt(il,i)*(water(il,i+1)-water(il,i)))/ &
-                        (sigd(il)*(ph(il,i)-ph(il,i+1))*100.)
+          ! print *, 'evap sans ice'
+          evap(il, i) = (wdtrain(il) + sigd(il) * wt(il, i) * (water(il, i + 1) - water(il, i))) / &
+                  (sigd(il) * (ph(il, i) - ph(il, i + 1)) * 100.)
 
         END IF
       END IF !(i.le.inb(il) .AND. lwork(il))
     END DO
-! ----------------------------------------------------------------
-
-! cc
-! ***  calculate precipitating downdraft mass flux under     ***
-! ***              hydrostatic approximation                 ***
+    ! ----------------------------------------------------------------
+
+    ! cc
+    ! ***  calculate precipitating downdraft mass flux under     ***
+    ! ***              hydrostatic approximation                 ***
 
     DO il = 1, ncum
       IF (i<=inb(il) .AND. lwork(il) .AND. i/=1) THEN
 
-        tevap(il) = max(0.0, evap(il,i))
-        delth = max(0.001, (th(il,i)-th(il,i-1)))
+        tevap(il) = max(0.0, evap(il, i))
+        delth = max(0.001, (th(il, i) - th(il, i - 1)))
         IF (cvflag_ice) THEN
           IF (cvflag_grav) THEN
-            mp(il, i) = 100.*ginv*(lvcp(il,i)*sigd(il)*tevap(il)* &
-                                               (p(il,i-1)-p(il,i))/delth + &
-                                   lfcp(il,i)*sigd(il)*faci(il,i)*tevap(il)* &
-                                               (p(il,i-1)-p(il,i))/delth + &
-                                   lfcp(il,i)*sigd(il)*wt(il,i)/100.*fondue(il,i)* &
-                                               (p(il,i-1)-p(il,i))/delth/(ph(il,i)-ph(il,i+1)))
+            mp(il, i) = 100. * ginv * (lvcp(il, i) * sigd(il) * tevap(il) * &
+                    (p(il, i - 1) - p(il, i)) / delth + &
+                    lfcp(il, i) * sigd(il) * faci(il, i) * tevap(il) * &
+                            (p(il, i - 1) - p(il, i)) / delth + &
+                    lfcp(il, i) * sigd(il) * wt(il, i) / 100. * fondue(il, i) * &
+                            (p(il, i - 1) - p(il, i)) / delth / (ph(il, i) - ph(il, i + 1)))
           ELSE
-            mp(il, i) = 10.*(lvcp(il,i)*sigd(il)*tevap(il)* &
-                                                (p(il,i-1)-p(il,i))/delth + &
-                             lfcp(il,i)*sigd(il)*faci(il,i)*tevap(il)* &
-                                                (p(il,i-1)-p(il,i))/delth + &
-                             lfcp(il,i)*sigd(il)*wt(il,i)/100.*fondue(il,i)* &
-                                                (p(il,i-1)-p(il,i))/delth/(ph(il,i)-ph(il,i+1)))
+            mp(il, i) = 10. * (lvcp(il, i) * sigd(il) * tevap(il) * &
+                    (p(il, i - 1) - p(il, i)) / delth + &
+                    lfcp(il, i) * sigd(il) * faci(il, i) * tevap(il) * &
+                            (p(il, i - 1) - p(il, i)) / delth + &
+                    lfcp(il, i) * sigd(il) * wt(il, i) / 100. * fondue(il, i) * &
+                            (p(il, i - 1) - p(il, i)) / delth / (ph(il, i) - ph(il, i + 1)))
 
           END IF
         ELSE
           IF (cvflag_grav) THEN
-            mp(il, i) = 100.*ginv*lvcp(il, i)*sigd(il)*tevap(il)* &
-                                                (p(il,i-1)-p(il,i))/delth
+            mp(il, i) = 100. * ginv * lvcp(il, i) * sigd(il) * tevap(il) * &
+                    (p(il, i - 1) - p(il, i)) / delth
           ELSE
-            mp(il, i) = 10.*lvcp(il, i)*sigd(il)*tevap(il)* &
-                                                (p(il,i-1)-p(il,i))/delth
+            mp(il, i) = 10. * lvcp(il, i) * sigd(il) * tevap(il) * &
+                    (p(il, i - 1) - p(il, i)) / delth
           END IF
 
@@ -3228,34 +3199,34 @@
       END IF !(i.le.inb(il) .AND. lwork(il) .AND. i.NE.1)
       IF (prt_level >= 20) THEN
-        PRINT *,'cv3_unsat, mp hydrostatic ', i, mp(il,i)
+        PRINT *, 'cv3_unsat, mp hydrostatic ', i, mp(il, i)
       ENDIF
     END DO
-! ----------------------------------------------------------------
-
-! ***           if hydrostatic assumption fails,             ***
-! ***   solve cubic difference equation for downdraft theta  ***
-! ***  and mass flux from two simultaneous differential eqns ***
+    ! ----------------------------------------------------------------
+
+    ! ***           if hydrostatic assumption fails,             ***
+    ! ***   solve cubic difference equation for downdraft theta  ***
+    ! ***  and mass flux from two simultaneous differential eqns ***
 
     DO il = 1, ncum
       IF (i<=inb(il) .AND. lwork(il) .AND. i/=1) THEN
 
-        amfac = sigd(il)*sigd(il)*70.0*ph(il, i)*(p(il,i-1)-p(il,i))* &
-                         (th(il,i)-th(il,i-1))/(tv(il,i)*th(il,i))
-        amp2 = abs(mp(il,i+1)*mp(il,i+1)-mp(il,i)*mp(il,i))
-
-        IF (amp2>(0.1*amfac)) THEN
-          xf = 100.0*sigd(il)*sigd(il)*sigd(il)*(ph(il,i)-ph(il,i+1))
-          tf = b(il, i) - 5.0*(th(il,i)-th(il,i-1))*t(il, i) / &
-                              (lvcp(il,i)*sigd(il)*th(il,i))
-          af = xf*tf + mp(il, i+1)*mp(il, i+1)*tinv
+        amfac = sigd(il) * sigd(il) * 70.0 * ph(il, i) * (p(il, i - 1) - p(il, i)) * &
+                (th(il, i) - th(il, i - 1)) / (tv(il, i) * th(il, i))
+        amp2 = abs(mp(il, i + 1) * mp(il, i + 1) - mp(il, i) * mp(il, i))
+
+        IF (amp2>(0.1 * amfac)) THEN
+          xf = 100.0 * sigd(il) * sigd(il) * sigd(il) * (ph(il, i) - ph(il, i + 1))
+          tf = b(il, i) - 5.0 * (th(il, i) - th(il, i - 1)) * t(il, i) / &
+                  (lvcp(il, i) * sigd(il) * th(il, i))
+          af = xf * tf + mp(il, i + 1) * mp(il, i + 1) * tinv
 
           IF (cvflag_ice) THEN
-            bf = 2.*(tinv*mp(il,i+1))**3 + tinv*mp(il, i+1)*xf*tf + &
-                 50.*(p(il,i-1)-p(il,i))*xf*(tevap(il)*(1.+(lf(il,i)/lv(il,i))*faci(il,i)) + &
-                (lf(il,i)/lv(il,i))*wt(il,i)/100.*fondue(il,i)/(ph(il,i)-ph(il,i+1)))
+            bf = 2. * (tinv * mp(il, i + 1))**3 + tinv * mp(il, i + 1) * xf * tf + &
+                    50. * (p(il, i - 1) - p(il, i)) * xf * (tevap(il) * (1. + (lf(il, i) / lv(il, i)) * faci(il, i)) + &
+                            (lf(il, i) / lv(il, i)) * wt(il, i) / 100. * fondue(il, i) / (ph(il, i) - ph(il, i + 1)))
           ELSE
 
-            bf = 2.*(tinv*mp(il,i+1))**3 + tinv*mp(il, i+1)*xf*tf + &
-                                           50.*(p(il,i-1)-p(il,i))*xf*tevap(il)
+            bf = 2. * (tinv * mp(il, i + 1))**3 + tinv * mp(il, i + 1) * xf * tf + &
+                    50. * (p(il, i - 1) - p(il, i)) * xf * tevap(il)
           END IF
 
